#!/usr/bin/python
##### Aragova tocka - S53MV 12.03.2018 #####

import math,cmath	#uporabljene funkcije

ka=0.005	#korak polmera [m]
amax=1		#polmer odprtine [m]
ll=0.03		#valovna dolzina [m]
d=2.95		#razdalja do zaslona [m]
kz=0.01		#korak po zaslonu [m]
zmin=-3		#zacetek uklona [m]
zmax=3		#konec zaslona [m]

kf=math.pi/int(3/ka/amax)	#korak kota
k=2*math.pi/ll	#valovno stevilo [rd/m]

x=[]		#polja za risanje grafa
y=[]
z=[]

zz=zmin
while zz<zmax:			#zanka cez zaslon
	s=0
	a=ka/2
	while a<amax:		#zanka po polmeru odprtine
		f=kf/2
		while f<2*math.pi:	#zanka po azimutu odprtine
			xo=a*math.cos(f)
			yo=a*math.sin(f)
			r=math.sqrt((xo-zz)*(xo-zz)+yo*yo+d*d)
			s=s+cmath.exp(complex(0,-k*r))*a*(1+d/r)/r
			f=f+kf
		a=a+ka
	s=s*complex(0,1)*k*cmath.exp(complex(0,k*d))*ka*kf/(2*math.pi*2)
	y=y+[abs(s)]
	z=z+[abs(s-1)]
	x=x+[zz]
	zz=zz+kz

import matplotlib.pyplot as plt		#risanje grafa funkcije
fig=plt.figure(figsize=(4,8))
plt.plot(y,x,'m-')
plt.axis([0,2,zmin,zmax])
plt.xticks([0,1,2],['0',r'$E_\infty$',r'2$E_\infty$'])
plt.grid(True)
fig.savefig('arago1.svg', transparent=True)
fig=plt.figure(figsize=(4,8))
plt.plot(z,x,'m-')
plt.axis([0,2,zmin,zmax])
plt.xticks([0,1,2],['0',r'$E_\infty$',r'2$E_\infty$'])
plt.grid(True)
fig.savefig('arago2.svg', transparent=True)
plt.show()

#konec programa

